/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-08-17 11:36:14.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.oe.admin.api.bean;

import java.util.List;
import java.util.stream.Collectors;

import com.google.common.collect.Lists;

import cn.com.qmth.examcloud.core.oe.admin.api.request.ExamStudentSyncAllDataReq;
import cn.com.qmth.examcloud.core.oe.admin.api.request.ExamStudentSyncPartDataReq;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examstudent.ExamStudentInfo;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examstudent.ExamStudentPartInfo;
import cn.com.qmth.examcloud.global.api.request.SyncExamStudentReq;
import cn.com.qmth.examcloud.api.commons.exchange.JsonSerializable;

/**
 * 类信息转换
 *
 * @author: fengdesheng
 * @since: 2018/8/17
 */
public class ExamStudentBeanConvert implements JsonSerializable {

    public static ExamStudentInfo of(ExamStudentSyncAllDataBean bean) {
        if (bean == null) {
            return null;
        }
        ExamStudentInfo info = new ExamStudentInfo();
        info.setExamStudentId(bean.getExamStudentId());
        info.setExamId(bean.getExamId());
        info.setStudentId(bean.getStudentId());
        info.setStudentCode(bean.getStudentCode());
        info.setStudentName(bean.getStudentName());
        info.setIdentityNumber(bean.getIdentityNumber());
        info.setCourseId(bean.getCourseId());
        info.setCourseCode(bean.getCourseCode());
        info.setCourseName(bean.getCourseName());
        info.setCourseLevel(bean.getCourseLevel());
        info.setOrgId(bean.getOrgId());
        info.setOrgCode(bean.getOrgCode());
        info.setOrgName(bean.getOrgName());
        info.setRootOrgId(bean.getRootOrgId());
        info.setSpecialtyCode(bean.getSpecialtyCode());
        info.setSpecialtyName(bean.getSpecialtyName());
        info.setPaperType(bean.getPaperType());
        info.setInfoCollector(bean.getInfoCollector());
        info.setFinished(bean.getFinished());
        info.setNormalExamTimes(bean.getNormalExamTimes());
        info.setIsReExamine(bean.getReExamine());
        info.setReExamineCompleted(bean.getReExamineCompleted());
        return info;
    }

    public static ExamStudentPartInfo of(ExamStudentSyncPartDataBean bean) {
        if (bean == null) {
            return null;
        }
        ExamStudentPartInfo info = new ExamStudentPartInfo();
        info.setStudentId(bean.getStudentId());
        info.setStudentCode(bean.getStudentCode());
        info.setStudentName(bean.getStudentName());
        info.setIdentityNumber(bean.getIdentityNumber());
        return info;
    }

    public static List<ExamStudentInfo> of(ExamStudentSyncAllDataReq req) {
        if (req == null) {
            return Lists.newArrayList();
        }
        List<ExamStudentSyncAllDataBean> beans = req.getExamStudents();
        return beans.stream().map(bean -> of(bean)).collect(Collectors.toList());
    }

    public static List<ExamStudentPartInfo> of(ExamStudentSyncPartDataReq req) {
        if (req == null) {
            return Lists.newArrayList();
        }
        List<ExamStudentSyncPartDataBean> beans = req.getExamStudents();
        return beans.stream().map(bean -> of(bean)).collect(Collectors.toList());
    }

    public static ExamStudentInfo of(SyncExamStudentReq req) {
        ExamStudentInfo info = new ExamStudentInfo();
        info.setExamStudentId(req.getId());
        info.setExamId(req.getExamId());
        info.setStudentId(req.getStudentId());
        info.setStudentCode(req.getStudentCode());
        info.setStudentName(req.getStudentName());
        info.setIdentityNumber(req.getIdentityNumber());
        info.setCourseId(req.getCourseId());
        info.setCourseCode(req.getCourseCode());
        info.setCourseName(req.getCourseName());
        info.setCourseLevel(req.getCourseLevel());
        info.setOrgId(req.getOrgId());
        info.setOrgCode(req.getOrgCode());
        info.setOrgName(req.getOrgName());
        info.setRootOrgId(req.getRootOrgId());
        info.setSpecialtyName(req.getSpecialtyName());
        info.setPaperType(req.getPaperType());
        info.setInfoCollector(req.getInfoCollector());
        info.setGrade(req.getGrade());
        info.setExamSiteName(req.getExamSite());
        info.setFinished(false);
        info.setNormalExamTimes(0);
        info.setIsReExamine(false);
        info.setReExamineCompleted(false);
        info.setEnable(req.getEnable());
        return info;
    }

}