/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-08-31 17:26:51.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.oe.admin.api.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.admin.service.ExamCaptureService;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examcapture.ExamCaptureAuditInfo;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examcapture.ExamCaptureInfo;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 考试抓拍检测相关接口
 *
 * @author: fengdesheng
 * @since: 2018/8/27
 */
@RestController
@Api(tags = "考试抓拍检测相关接口")
@RequestMapping("${$rmp.ctr.oe}/exam/capture")
public class ExamCaptureController extends ControllerSupport {
    @Autowired
    private ExamCaptureService examCaptureService;

    @PostMapping("/audit/detail")
    @ApiOperation(value = "抓拍详情-审核详细信息")
    public ExamCaptureAuditInfo getAuditDetail(@RequestParam Long examRecordDataId) {
        return examCaptureService.getExamCaptureAuditDetail(examRecordDataId);
    }

    @PostMapping("/list")
    @ApiOperation(value = "抓拍详情-抓拍记录列表")
    public List<ExamCaptureInfo> list(@RequestParam Long examRecordDataId) {
        return examCaptureService.getExamCaptureList(examRecordDataId);
    }

}