package cn.com.qmth.examcloud.core.oe.admin.api.controller;

import java.util.ArrayList;
import java.util.List;

import cn.com.qmth.examcloud.core.oe.admin.api.bean.ExamRecordDataBeanConvert;
import cn.com.qmth.examcloud.core.oe.admin.api.bean.ExamRecordDataDomain;
import io.swagger.annotations.Api;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordDataEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordDataRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordRepo;
import cn.com.qmth.examcloud.web.helpers.GlobalHelper;


@RestController
@Api(tags = "考试记录相关接口")
@RequestMapping("${$rmp.ctr.oe}/exam/record/data")
public class ExamRecordDataController {

    @Autowired
    private ExamRecordDataRepo examRecordDataRepo;

    @Autowired
    private ExamRecordRepo examRecordRepo;

    @GetMapping("/findExamRecordDataEntity")
    public ExamRecordDataDomain findExamRecordDataEntity(@RequestParam Long examRecordDataId) {
        ExamRecordDataDomain domain = ExamRecordDataBeanConvert.copyFrom(
                GlobalHelper.getEntity(examRecordDataRepo, examRecordDataId, ExamRecordDataEntity.class));
        domain.setExamRecord(GlobalHelper.getEntity(examRecordRepo, domain.getExamRecordId(), ExamRecordEntity.class));
        return domain;
    }

    @GetMapping("/findByExamStudentId")
    public List<ExamRecordDataDomain> findByExamStudentId(@RequestParam Long examStudentId) {
        List<ExamRecordEntity> examRecordEntities = examRecordRepo.findByExamStudentId(examStudentId);
        List<ExamRecordDataDomain> examRecordDataList = new ArrayList<ExamRecordDataDomain>();
        for (ExamRecordEntity examRecord : examRecordEntities) {
            ExamRecordDataDomain domain = ExamRecordDataBeanConvert.copyFrom(
                    examRecordDataRepo.findByExamRecordId(examRecord.getId()));
            domain.setExamRecord(examRecord);
            examRecordDataList.add(domain);
        }
        return examRecordDataList;
    }
}
