package cn.com.qmth.examcloud.core.oe.admin.api.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.admin.service.ExamRecordPaperStructService;
import cn.com.qmth.examcloud.core.oe.common.base.utils.Check;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordPaperStructEntity;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 
 * @author  	chenken
 * @date    	2018年9月5日 下午4:02:15
 * @company 	QMTH
 * @description 考试记录-试卷结构controller
 */
@Api(tags = "考试记录-试卷结构")
@RestController
@RequestMapping("${$rmp.ctr.oe}/examRecordPaperStruct")
public class ExamRecordPaperStructController extends ControllerSupport{

	@Autowired
	private ExamRecordPaperStructService examRecordPaperStructService;
	
	@ApiOperation(value = "获取考试记录试卷结构")
	@GetMapping("/getExamRecordPaperStruct")
	public ExamRecordPaperStructEntity getExamRecordPaperStruct(@RequestParam Long examRecordDataId){
		Check.isNull(examRecordDataId, "examRecordDataId不能为空");
		return examRecordPaperStructService.getExamRecordPaperStruct(examRecordDataId);
	}
	
}
