package cn.com.qmth.examcloud.core.oe.admin.api.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.common.base.utils.Check;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamRecordQuestionsEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordQuestionsRepo;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;


/**
 * 
 * @author  	chenken
 * @date    	2018年10月12日 上午9:48:47
 * @company 	QMTH
 * @description ExamRecordQuestionsController.java
 */
@Api(tags = "考试结束后-作答记录接口")
@RestController
@RequestMapping("${$rmp.ctr.oe}/examRecordQuestions")
public class ExamRecordQuestionsController extends ControllerSupport{

	@Autowired
	private ExamRecordQuestionsRepo examRecordQuestionsRepo;
	
	@ApiOperation(value = "获取交卷之后的所有试题作答信息")
	@GetMapping("/getExamRecordQuestions")
	public ExamRecordQuestionsEntity getExamRecordQuestions(@RequestParam Long examRecordDataId){
		Check.isNull(examRecordDataId, "examRecordDataId不能为空");
		return examRecordQuestionsRepo.findByExamRecordDataId(examRecordDataId);
	}
	
}
