/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-08-31 09:28:03.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.oe.admin.api.controller;

import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.admin.service.ExamScoreService;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examscore.ExamScoreInfo;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examscore.ExamScoreQuery;
import cn.com.qmth.examcloud.core.oe.common.base.utils.Check;
import cn.com.qmth.examcloud.core.oe.common.base.utils.JsonMapper;
import cn.com.qmth.examcloud.core.oe.common.base.utils.excel.ExportUtils;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import cn.com.qmth.examcloud.web.support.Naked;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 考试分数相关接口
 *
 * @author: fengdesheng
 * @since: 2018/8/27
 */
@RestController
@Api(tags = "考试分数相关接口")
@RequestMapping("${$rmp.ctr.oe}/exam/score")
public class ExamScoreController extends ControllerSupport {
    @Autowired
    private ExamScoreService examScoreService;

    @PostMapping("/statistic/list")
    @ApiOperation(value = "查询“成绩统计”列表(分页)")
    public Page<ExamScoreInfo> getExamAuditList(@RequestBody ExamScoreQuery query) {
        return examScoreService.getExamScoreList(query);
    }

    @Naked
    @GetMapping("/statistic/list/export")
    @ApiOperation(value = "导出“成绩统计”列表(Excel)", notes = "参数示例：query={\"pageNo\":1,\"pageSize\":10,\"examId\":123, ...}")
    public void exportExamRecordDetailList(@RequestParam String query, HttpServletResponse response) throws Exception {
        ExamScoreQuery newQuery = new JsonMapper().fromJson(query, ExamScoreQuery.class);
        Check.isNull(newQuery, "请求参数不能为空！");
        Check.isNull(newQuery.getExamId(), "请先选择考试批次！");
        List<ExamScoreInfo> examScoreList = examScoreService.exportExamScoreList(newQuery);
        ExportUtils.exportEXCEL("成绩统计列表", ExamScoreInfo.class,examScoreList,response);
    }

}