package cn.com.qmth.examcloud.core.oe.admin.api.provider;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.admin.api.ExamRecordQuestionsCloudService;
import cn.com.qmth.examcloud.core.oe.admin.api.bean.QuerySubjectiveAnswerBean;
import cn.com.qmth.examcloud.core.oe.admin.api.bean.SaveSubjectiveQuestionScoreBean;
import cn.com.qmth.examcloud.core.oe.admin.api.request.QuerySubjectiveAnswerListReq;
import cn.com.qmth.examcloud.core.oe.admin.api.request.SaveSubjectiveQuestionScoreReq;
import cn.com.qmth.examcloud.core.oe.admin.api.response.QuerySubjectiveAnswerListResp;
import cn.com.qmth.examcloud.core.oe.admin.service.ExamRecordQuestionsService;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.SubjectiveQuestionScoreInfo;
import cn.com.qmth.examcloud.core.oe.common.base.utils.Check;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamQuestionEntity;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 
 * @author  	chenken
 * @date    	2018年9月27日 上午11:02:55
 * @company 	QMTH
 * @description 学生作答答案相关接口
 */
@Api(tags = "学生作答答案相关接口")
@RestController
@RequestMapping("${$rmp.cloud.oe}/examRecordQuestions")
public class ExamRecordQuestionsCloudServiceProvider extends ControllerSupport implements ExamRecordQuestionsCloudService{

	private static final long serialVersionUID = -1058894529829651231L;
	
	@Autowired
	private ExamRecordQuestionsService examRecordQuestionsService;
	
	/**
	 * 阅卷获取考试记录主观题答案信息
	 */
	@Override
	@ApiOperation(value = "阅卷获取考试记录主观题答案信息")
	@PostMapping("/querySubjectiveAnswerList")
	public QuerySubjectiveAnswerListResp querySubjectiveAnswerList(@RequestBody QuerySubjectiveAnswerListReq req) {
		List<ExamQuestionEntity> examQuestionList = examRecordQuestionsService.querySubjectiveAnswerList(req.getExamRecordDataId());
		QuerySubjectiveAnswerListResp resp = new QuerySubjectiveAnswerListResp();
		List<QuerySubjectiveAnswerBean> querySubjectiveAnswerBeanList = new ArrayList<QuerySubjectiveAnswerBean>();
		for(ExamQuestionEntity examQuestionEntity:examQuestionList){
			QuerySubjectiveAnswerBean querySubjectiveAnswerBean = new QuerySubjectiveAnswerBean();
			querySubjectiveAnswerBean.setExamRecordDataId(examQuestionEntity.getExamRecordDataId());
			querySubjectiveAnswerBean.setMainNumber(examQuestionEntity.getMainNumber());
			querySubjectiveAnswerBean.setOrder(examQuestionEntity.getOrder());
			querySubjectiveAnswerBean.setQuestionId(examQuestionEntity.getQuestionId());
			querySubjectiveAnswerBean.setStudentAnswer(examQuestionEntity.getStudentAnswer());
			querySubjectiveAnswerBean.setAnswerType(examQuestionEntity.getAnswerType());
			querySubjectiveAnswerBeanList.add(querySubjectiveAnswerBean);
		}
		resp.setQuerySubjectiveAnswerBeanList(querySubjectiveAnswerBeanList);
		return resp;
	}

	@Override
	@ApiOperation(value = "阅卷回传主观题得分")
	@PostMapping("/saveSubjectiveQuestionScore")
	public void saveSubjectiveQuestionScore(@RequestBody SaveSubjectiveQuestionScoreReq req) {
		Check.isNull(req.getExamRecordDataId(), "examRecordDataId 不能为空");
		List<SaveSubjectiveQuestionScoreBean> saveSubjectiveQuestionScoreList = req.getSaveSubjectiveQuestionScoreList();
		if(saveSubjectiveQuestionScoreList == null || saveSubjectiveQuestionScoreList.size() == 0){
			return;
		}
		long examRecordDataId = req.getExamRecordDataId();
		List<SubjectiveQuestionScoreInfo> subjectiveQuestionScoreInfoList = new ArrayList<SubjectiveQuestionScoreInfo>();
		for(SaveSubjectiveQuestionScoreBean bean:saveSubjectiveQuestionScoreList){
			SubjectiveQuestionScoreInfo info = new SubjectiveQuestionScoreInfo();
			info.setExamRecordDataId(bean.getExamRecordDataId());
			info.setOrder(bean.getOrder());
			info.setQuestionId(bean.getQuestionId());
			info.setScore(bean.getScore());
			subjectiveQuestionScoreInfoList.add(info);
		}
		examRecordQuestionsService.saveSubjectiveQuestionScore(examRecordDataId, subjectiveQuestionScoreInfoList);
	}

}
