package cn.com.qmth.examcloud.core.oe.admin.api.provider;

import java.util.ArrayList;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.core.oe.admin.api.ExamScoreCloudService;
import cn.com.qmth.examcloud.core.oe.admin.api.bean.ExamScoreBean;
import cn.com.qmth.examcloud.core.oe.admin.api.request.QueryExamScoreReq;
import cn.com.qmth.examcloud.core.oe.admin.api.response.QueryExamScoreResp;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamScoreEntity;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamScoreRepo;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;


@Api(tags = "考试分数信息相关接口")
@RestController
@RequestMapping("${$rmp.cloud.oe}/examScore")
public class ExamScoreCloudServiceProvider extends ControllerSupport implements ExamScoreCloudService{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1957765271029136836L;
	
	@Autowired
	private ExamScoreRepo examScoreRepo;
	
	@Override
	@ApiOperation(value = "分数查询")
	@PostMapping("/queryExamScore")
	public QueryExamScoreResp queryExamScore(@RequestBody QueryExamScoreReq req) {
		List<Long> examRecordDataIds = req.getExamRecordDataIds();
		
		if(examRecordDataIds == null || examRecordDataIds.size() == 0){
			return null;
		}
		
		List<ExamScoreEntity> examScoreList = examScoreRepo.findByExamRecordDataIdIn(req.getExamRecordDataIds());
		
		List<ExamScoreBean> examScoreBeans = new ArrayList<ExamScoreBean>();
		for(ExamScoreEntity examScore:examScoreList){
			ExamScoreBean examScoreBean = new ExamScoreBean();
			examScoreBean.setId(examScore.getId());
			examScoreBean.setExamRecordDataId(examScore.getExamRecordDataId());
			examScoreBean.setObjectiveAccuracy(examScore.getObjectiveAccuracy());
			examScoreBean.setObjectiveScore(examScore.getObjectiveScore());
			examScoreBean.setSubjectiveScore(examScore.getSubjectiveScore());
			examScoreBean.setSuccPercent(examScore.getSuccPercent());
			examScoreBean.setTotalScore(examScore.getTotalScore());
			examScoreBeans.add(examScoreBean);
		}
		QueryExamScoreResp queryExamScoreResp = new QueryExamScoreResp();
		queryExamScoreResp.setExamScoreBeans(examScoreBeans);
		return queryExamScoreResp;
	}

}
