/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-08-27 16:20:17.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.oe.admin.service;

import java.util.List;

import org.springframework.data.domain.Page;

import cn.com.qmth.examcloud.core.oe.admin.service.bean.examaudit.ExamAuditInfo;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examaudit.ExamAuditQuery;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.examaudit.RedoAuditInfo;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamAuditEntity;
import cn.com.qmth.examcloud.core.oe.common.enums.DisciplineType;
import cn.com.qmth.examcloud.api.commons.security.bean.User;

/**
 * 考试记录审核相关接口
 *
 * @author: fengdesheng
 * @since: 2018/8/15
 */
public interface ExamAuditService {

    /**
     * 查询监考已审列表(分页)
     *
     * @param query
     * @return
     */
    Page<ExamAuditInfo> getExamAuditList(ExamAuditQuery query);


    /**
     * 获取审核信息
     *
     * @param examRecordDataId
     * @return
     */
    ExamAuditEntity getExamAuditByExamRecordDataId(Long examRecordDataId);
    
    /**
     * 监考待审-批量审核
     *
     * @param examRecordIds
     * @param isPass
     * @param disciplineDetail
     * @param userId
     */
    void batchAudit(List<Long> examRecordDataIds, Boolean isPass,User user);

    /**
     * 单个审核
     * @param examRecordDataId
     * @param isPass
     * @param disciplineDetail
     * @param disciplineType
     */
	void singleAudit(Long examRecordDataId, Boolean isPass,String disciplineDetail, DisciplineType disciplineType,User user);

	/**
	 * 重新审核
	 * @param redoAuditInfo
	 * @param user
	 */
	public void redoAudit(RedoAuditInfo redoAuditInfo,User user);

}