/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-09-11 16:59:23.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.oe.admin.service.bean;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import cn.com.qmth.examcloud.core.oe.common.base.utils.NewQuestionType;

/**
 * 考试作答试题集合
 *
 * @author: fengdesheng
 * @since: 2018/9/11
 */
public class ExamRecordQuestionsInfo implements Serializable {
    private static final long serialVersionUID = -1688201571728312142L;
    private String id;
    private Long examRecordDataId;
    private Date creationTime;
    private List<ExamQuestionEntity> examQuestionEntities;

    public void addExamQuestion(ExamQuestionEntity examQuestion) {
        if (examQuestionEntities == null) {
            examQuestionEntities = new ArrayList<>();
        }
        examQuestionEntities.add(examQuestion);
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Long getExamRecordDataId() {
        return examRecordDataId;
    }

    public void setExamRecordDataId(Long examRecordDataId) {
        this.examRecordDataId = examRecordDataId;
    }

    public Date getCreationTime() {
        return creationTime;
    }

    public void setCreationTime(Date creationTime) {
        this.creationTime = creationTime;
    }

    public List<ExamQuestionEntity> getExamQuestionEntities() {
        return examQuestionEntities;
    }

    public void setExamQuestionEntities(List<ExamQuestionEntity> examQuestionEntities) {
        this.examQuestionEntities = examQuestionEntities;
    }

    public static ExamQuestionEntity createExamQuestionEntity() {
        return new ExamQuestionEntity();
    }

    public static class ExamQuestionEntity {
        /**
         * 大题号
         */
        private Integer mainNumber;
        /**
         * 原题ID
         */
        private String questionId;
        /**
         * 顺序
         */
        private Integer order;
        /**
         * 小题分数
         */
        private Float questionScore;
        /**
         * 小题类型
         */
        private NewQuestionType questionType;
        /**
         * 标准答案
         */
        private String correctAnswer;
        /**
         * 考生作答
         */
        private String studentAnswer;
        /**
         * 学生小题得分
         */
        private Float studentScore;
        /**
         * 是否作答
         */
        private Boolean isAnswer;
        /**
         * 是否标记
         */
        private Boolean isSign;
        
        private Integer[] optionPermutation;

        public Integer getMainNumber() {
            return mainNumber;
        }

        public void setMainNumber(Integer mainNumber) {
            this.mainNumber = mainNumber;
        }

        public String getQuestionId() {
            return questionId;
        }

        public void setQuestionId(String questionId) {
            this.questionId = questionId;
        }

        public Integer getOrder() {
            return order;
        }

        public void setOrder(Integer order) {
            this.order = order;
        }

        public Float getQuestionScore() {
            return questionScore;
        }

        public void setQuestionScore(Float questionScore) {
            this.questionScore = questionScore;
        }

        public NewQuestionType getQuestionType() {
            return questionType;
        }

        public void setQuestionType(NewQuestionType questionType) {
            this.questionType = questionType;
        }

        public String getCorrectAnswer() {
            return correctAnswer;
        }

        public void setCorrectAnswer(String correctAnswer) {
            this.correctAnswer = correctAnswer;
        }

        public String getStudentAnswer() {
            return studentAnswer;
        }

        public void setStudentAnswer(String studentAnswer) {
            this.studentAnswer = studentAnswer;
        }

        public Float getStudentScore() {
            return studentScore;
        }

        public void setStudentScore(Float studentScore) {
            this.studentScore = studentScore;
        }

        public Boolean getAnswer() {
            return isAnswer;
        }

        public void setAnswer(Boolean answer) {
            this.isAnswer = answer;
        }

        public Boolean getSign() {
            return isSign;
        }

        public void setSign(Boolean sign) {
            this.isSign = sign;
        }

		public Integer[] getOptionPermutation() {
			return optionPermutation;
		}

		public void setOptionPermutation(Integer[] optionPermutation) {
			this.optionPermutation = optionPermutation;
		}
        
    }

}