/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-08-24 11:25:56.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.oe.admin.service.bean.examstudent;

/**
 * 实体元数据
 *
 * @author: fengdesheng
 * @since: 2018/8/24
 */
public class ExamStudentMapper {

    public static final String ID = "id";
    public static final String EXAM_STUDENT_ID = "examStudentId";
    public static final String EXAM_ID = "examId";
    public static final String STUDENT_ID = "studentId";
    public static final String STUDENT_CODE = "studentCode";
    public static final String STUDENT_NAME = "studentName";
    public static final String IDENTITY_NUMBER = "identityNumber";
    public static final String COURSE_ID = "courseId";
    public static final String COURSE_CODE = "courseCode";
    public static final String COURSE_NAME = "courseName";
    public static final String COURSE_LEVEL = "courseLevel";
    public static final String ORG_ID = "orgId";
    public static final String ORG_CODE = "orgCode";
    public static final String ORG_NAME = "orgName";
    public static final String ROOT_ORG_ID = "rootOrgId";
    public static final String SPECIALTY_CODE = "specialtyCode";
    public static final String SPECIALTY_NAME = "specialtyName";
    public static final String PAPER_TYPE = "paperType";
    public static final String INFO_COLLECTOR = "infoCollector";
    public static final String FINISHED = "finished";
    public static final String NORMAL_EXAM_TIMES = "normalExamTimes";
    public static final String IS_RE_EXAMINE = "isReExamine";
    public static final String RE_EXAMINE_COMPLETED = "reExamineCompleted";
    public static final String CREATION_TIME = "creationTime";
    public static final String UPDATE_TIME = "updateTime";

    public static String defaultColumns() {
        StringBuilder columns = new StringBuilder();
        columns.append("student.id as id,");
        columns.append("student.exam_student_id as examStudentId,");
        columns.append("student.exam_id as examId,");
        columns.append("student.student_id as studentId,");
        columns.append("student.student_code as studentCode,");
        columns.append("student.student_name as studentName,");
        columns.append("student.identity_number as identityNumber,");
        columns.append("student.course_id as courseId,");
        columns.append("student.course_code as courseCode,");
        columns.append("student.course_level as courseLevel,");
        columns.append("student.org_id as orgId,");
        columns.append("student.specialty_name as specialtyName,");
        columns.append("student.finished as finished,");
        columns.append("student.normal_exam_times as normalExamTimes");
        return columns.toString();
    }

    public static String statisticOrgColumns() {
        StringBuilder columns = new StringBuilder();
        columns.append("student.org_id as orgId,");
        columns.append("COUNT(student.id) as totalCount,");
        columns.append("SUM(CASE WHEN student.finished = 1 THEN 1 ELSE 0 END) finishedCount");
        return columns.toString();
    }

    public static String statisticFinishedColumns() {
        StringBuilder columns = new StringBuilder();
        columns.append("SUM(CASE WHEN student.finished = 1 THEN 1 ELSE 0 END) finished,");
        columns.append("SUM(CASE WHEN student.finished = 1 THEN 0 ELSE 1 END) unFinished");
        return columns.toString();
    }

}