package cn.com.qmth.examcloud.core.oe.admin.service.impl;

import java.util.List;
import java.util.stream.Collectors;

import cn.com.qmth.examcloud.core.oe.common.entity.*;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.oe.admin.service.ExamRecordQuestionsService;
import cn.com.qmth.examcloud.core.oe.admin.service.bean.SubjectiveQuestionScoreInfo;
import cn.com.qmth.examcloud.core.oe.common.base.utils.QuestionTypeUtil;
import cn.com.qmth.examcloud.core.oe.common.enums.ExamType;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordDataRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordQuestionsRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamScoreRepo;
import cn.com.qmth.examcloud.web.helpers.GlobalHelper;

@Service("examRecordQuestionsService")
public class ExamRecordQuestionsServiceImpl implements ExamRecordQuestionsService {

	@Autowired
	private ExamRecordQuestionsRepo examRecordQuestionsRepo;
	
	@Autowired
	private ExamRecordDataRepo examRecordDataRepo;
	
	@Autowired
	private ExamScoreRepo examScoreRepo;

	@Autowired
	private ExamRecordRepo examRecordRepo;
	
	@Override
	public List<ExamQuestionEntity> querySubjectiveAnswerList(Long examRecordDataId) {
		ExamRecordQuestionsEntity examRecordQuestionsEntity = examRecordQuestionsRepo.findByExamRecordDataId(examRecordDataId);
		List<ExamQuestionEntity> examRecordQuestionList = examRecordQuestionsEntity.getExamQuestionEntities();
		
		return examRecordQuestionList.stream().filter((obj->{
			return !QuestionTypeUtil.isObjectiveQuestion(obj.getQuestionType());
		})).collect(Collectors.toList());
	}

	@Override
	public void saveSubjectiveQuestionScore(Long examRecordDataId,List<SubjectiveQuestionScoreInfo> subjectiveQuestionScoreInfoList) {
		ExamRecordDataEntity examRecordDataEntity = GlobalHelper.getEntity(examRecordDataRepo,examRecordDataId,ExamRecordDataEntity.class);
		ExamRecordEntity examRecord =GlobalHelper.getEntity(examRecordRepo,examRecordDataEntity.getExamRecordId(),ExamRecordEntity.class);
		if(examRecord.getExamType() == ExamType.ONLINE){
			ExamRecordQuestionsEntity examRecordQuestionsEntity = examRecordQuestionsRepo.findByExamRecordDataId(examRecordDataId);
			List<ExamQuestionEntity> examRecordQuestionList = examRecordQuestionsEntity.getExamQuestionEntities();
			
			for(SubjectiveQuestionScoreInfo scoreInfo:subjectiveQuestionScoreInfoList){
				for(ExamQuestionEntity examQuestionEntity:examRecordQuestionList){
					if(scoreInfo.getQuestionId().equals(examQuestionEntity.getQuestionId())
							&& scoreInfo.getOrder().intValue() == examQuestionEntity.getOrder().intValue()){
						examQuestionEntity.setStudentScore(scoreInfo.getScore());
						break;
					}
				}
			}
			examRecordQuestionsRepo.save(examRecordQuestionsEntity);
		}
		//计算主观题总得分
		double totalSubjectiveScore = 0D;
		for(SubjectiveQuestionScoreInfo scoreInfo:subjectiveQuestionScoreInfoList){
			totalSubjectiveScore += scoreInfo.getScore();
		}
		
		//更新ec_oe_exam_score
		ExamScoreEntity examScoreEntity = examScoreRepo.findByExamRecordDataId(examRecordDataId);
		examScoreEntity.setSubjectiveScore(totalSubjectiveScore);
		double totalScore = totalSubjectiveScore+examScoreEntity.getObjectiveScore();
		examScoreEntity.setTotalScore(totalScore);
		examScoreRepo.save(examScoreEntity);
	}

}
