/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-08-29 10:45:43.
 * *************************************************
 */

package cn.com.qmth.examcloud.core.oe.admin.service.impl;

import cn.com.qmth.examcloud.core.oe.admin.service.ExamService;
import cn.com.qmth.examcloud.core.oe.common.base.utils.Check;
import cn.com.qmth.examcloud.examwork.api.bean.ExamBean;
import cn.com.qmth.examcloud.examwork.api.client.ExamCloudServiceClient;
import cn.com.qmth.examcloud.examwork.api.request.GetExamReq;
import cn.com.qmth.examcloud.examwork.api.response.GetExamResp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * 考试相关接口
 * 基于Spring Cloud远程调用
 *
 * @author: fengdesheng
 * @since: 2018/8/29
 */
@Service
public class ExamServiceImpl implements ExamService {
    @Autowired
    private ExamCloudServiceClient examCloudServiceClient;

    @Override
    public String getExamNameById(Long examId) {
        ExamBean exam = this.getExam(examId);
        if (exam != null) {
            return exam.getName();
        }
        return null;
    }

    @Override
    public Long getExamTimesById(Long examId) {
        ExamBean exam = this.getExam(examId);
        if (exam != null) {
            return exam.getExamTimes();
        }
        return 0L;
    }

    @Override
    public ExamBean getExam(Long examId) {
        Check.isNull(examId, "考试ID不能为空！");
        GetExamReq req = new GetExamReq();
        req.setId(examId);
        GetExamResp resp = examCloudServiceClient.getExam(req);
        if (resp != null) {
            return resp.getExamBean();
        }
        return null;
    }

}