package cn.com.qmth.examcloud.core.oe.admin.service.impl.pushscore.swufe;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import cn.com.qmth.examcloud.core.oe.admin.service.ExamCacheTransferHelper;
import cn.com.qmth.examcloud.core.oe.common.entity.*;
import cn.com.qmth.examcloud.support.cache.CacheHelper;
import cn.com.qmth.examcloud.support.cache.bean.CourseCacheBean;
import cn.com.qmth.examcloud.support.cache.bean.ExamOrgSettingsCacheBean;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.basic.api.bean.CourseBean;
import cn.com.qmth.examcloud.core.oe.common.service.GainBaseDataService;
import cn.com.qmth.examcloud.core.oe.common.base.utils.CommonUtil;
import cn.com.qmth.examcloud.core.oe.common.enums.ExamScoreQueueStatus;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordDataRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamRecordRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamScorePushQueueRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamScoreRepo;
import cn.com.qmth.examcloud.core.oe.common.repository.ExamStudentRepo;
import cn.com.qmth.examcloud.core.oe.admin.service.ExamScoreQueueService;
import cn.com.qmth.examcloud.core.oe.admin.service.ExamScorePushService;
import cn.com.qmth.examcloud.core.oe.admin.service.impl.pushscore.bean.ExamScorePushInfo;
import cn.com.qmth.examcloud.examwork.api.bean.ExamBean;
import cn.com.qmth.examcloud.web.helpers.GlobalHelper;

/**
 * 
 * @author  	chenken
 * @date    	2018年10月18日 下午4:09:47
 * @company 	QMTH
 * @description 西南财经大学 orgCode:swufe.ecs.qmth.com.cn
 */
@Service("swufeExamScorePushServiceImpl")
public class SwufeExamScorePushServiceImpl implements ExamScorePushService{

	private static final Logger log = LoggerFactory.getLogger(SwufeExamScorePushServiceImpl.class);
	
	@Autowired
	private ExamScoreRepo examScoreRepo;
	
	@Autowired
	private ExamRecordDataRepo examRecordDataRepo;
	
	@Autowired
	private ExamRecordRepo examRecordRepo;
	
	@Autowired
	private ExamStudentRepo examStudentRepo;
	
	@Autowired
	private ExamScorePushQueueRepo examScorePushQueueRepo;
	
    @Autowired
    private GainBaseDataService gainBaseDataService;
    
	@Autowired
	private ExamScoreQueueService examScoreQueueService;
	
    private static final String pushScoreUrl = "http://www.swufe-online.com/netedu/qmth.do";
    
	@Override
	public void scorePush(ExamScorePushQueue examScorePushQueue) {
		log.info("开始推送西南财大成绩:"+examScorePushQueue.getId());
		Long scoreId = examScorePushQueue.getExamScoreId();
		ExamScoreEntity examScore = GlobalHelper.getEntity(examScoreRepo,scoreId,ExamScoreEntity.class);
		ExamRecordDataEntity examRecordData = GlobalHelper.getEntity(examRecordDataRepo,examScore.getExamRecordDataId(),ExamRecordDataEntity.class);

		ExamRecordEntity examRecord =GlobalHelper.getEntity(
				examRecordRepo,examRecordData.getExamRecordId(),ExamRecordEntity.class);
		ExamStudentEntity examStudent = examStudentRepo.findByExamStudentId(examRecord.getExamStudentId());
		if(examScore == null || examRecordData == null || examStudent == null){
			return;
		}
		ExamScorePushInfo examScorePushInfo = buildexamScorePushInfo(examScore,examRecordData,examStudent);
		
		if (examScorePushInfo != null) {
			 CloseableHttpResponse httpResponse = null;
			 CloseableHttpClient httpClient = null;
			 try {
	            httpClient = HttpClients.createDefault();
	            HttpPost httpPost = new HttpPost(pushScoreUrl);
	            List<NameValuePair> params = buildParamsData(examScorePushInfo);
	            httpPost.setEntity(new UrlEncodedFormEntity(params,"UTF-8"));
	            httpResponse = httpClient.execute(httpPost);
	            String result = "";
	            HttpEntity responseEntity = httpResponse.getEntity();
	            int statusCode= httpResponse.getStatusLine().getStatusCode();
	            if(statusCode == 200){
	                BufferedReader reader = new BufferedReader(new InputStreamReader(responseEntity.getContent()));
	                StringBuffer buffer = new StringBuffer();
	                String str = "";
	                while(StringUtils.isNoneBlank((str = reader.readLine()))) {
	                    buffer.append(str);
	                }
	                result = buffer.toString();
	            }
	            log.info("推送西南财大成绩:"+examScorePushQueue.getId()+"结果:"+result);
	            JSONObject jsonObject = new JSONObject(result);
	            if(jsonObject.getBoolean("success")){
	            	examScoreQueueService.saveExamScorePushQueue(result, examScorePushQueue, ExamScoreQueueStatus.PROCESS_SUCCESS);
	            }else{
	            	examScoreQueueService.saveExamScorePushQueue(result, examScorePushQueue, ExamScoreQueueStatus.PROCESS_FAILED);
	            }
			 }catch (Exception e) {
				log.error(examScorePushQueue.getId() + "成绩推送失败", e);
				examScoreQueueService.saveExamScorePushQueue(e.getMessage(), examScorePushQueue, ExamScoreQueueStatus.PROCESS_FAILED);
	        } finally {
	            if (httpResponse != null) {
	                try {
	                    httpResponse.close();
	                } catch (IOException e) {
	                    e.printStackTrace();
	                } finally {
	                    httpResponse = null;
	                }
	            }
	            if (httpClient != null) {
	                try {
	                    httpClient.close();
	                } catch (IOException e) {
	                    e.printStackTrace();
	                } finally {
	                    httpClient = null;
	                }
	            }
		    }
        }
	}

	private List<NameValuePair> buildParamsData(ExamScorePushInfo examScorePushInfo){
		Map<String,Object> map = CommonUtil.getKeyAndValue(examScorePushInfo);
        map.put("op","pushScore");
        map.put("x","xczx_white_list");
        map.put("LoginName","qmth");
        map.put("PassWord","qmth123!");
        
        //是否违纪
        boolean isIllegality = (boolean) map.get("isIllegality");
        map.put("isBreachThePrinciple", isIllegality?1:0);
        map.put("successRate", map.get("succPercent"));
        //以下属性西南财大接口不需要
        map.remove("succPercent");
        map.remove("isIllegality");
        map.remove("examRemark");
        map.remove("studentRemark");
        map.remove("isMissExam");
        map.remove("serialVersionUID");
        
        List<NameValuePair> params = new ArrayList<NameValuePair>();
        for(String key:map.keySet()){
        	params.add(new BasicNameValuePair(key,map.get(key)+""));
        }
        
        return params;
	}

	private ExamScorePushInfo buildexamScorePushInfo(ExamScoreEntity examScore,ExamRecordDataEntity examRecordDataEntity, ExamStudentEntity examStudentEntity) {
		ExamScorePushInfo examScorePushInfo = new ExamScorePushInfo();
		examScorePushInfo.setExamId(examStudentEntity.getExamId());

		ExamBean examBean = ExamCacheTransferHelper.getCachedExam(examStudentEntity.getExamId(),
				examStudentEntity.getOrgId());
		examScorePushInfo.setExamName(examBean.getName());
		
		examScorePushInfo.setStudentName(examStudentEntity.getStudentName());
		examScorePushInfo.setStudentCode(examStudentEntity.getStudentCode());
		examScorePushInfo.setIdentityNumber(examStudentEntity.getIdentityNumber());

		CourseBean courseBean = ExamCacheTransferHelper.getCachedCourse(examStudentEntity.getCourseId());
		examScorePushInfo.setCourseName(courseBean.getName());
		examScorePushInfo.setCourseCode(examStudentEntity.getCourseCode());
		examScorePushInfo.setStartTime(examRecordDataEntity.getStartTime());
		examScorePushInfo.setEndTime(examRecordDataEntity.getEndTime());
		examScorePushInfo.setSuccPercent(examRecordDataEntity.getFaceSuccessPercent());
		examScorePushInfo.setIsIllegality(examRecordDataEntity.getIsIllegality());
		examScorePushInfo.setScoreId(examScore.getId());
		examScorePushInfo.setTotalScore(examScore.getTotalScore());
		examScorePushInfo.setObjectiveScore(examScore.getObjectiveScore());
		examScorePushInfo.setSubjectiveScore(examScore.getSubjectiveScore());
		return examScorePushInfo;
	}

}
